import java.io.*;
import java.util.*;

public class TestGen {
    static final int MAX_V = 1_000_000_000;
    
    static PrintWriter out;
    static Random rnd = new Random(239017);
    static int tNumber = 1;
    
    static void printTest(int n, int[] a) throws IOException {
        System.out.println(String.format("Generating test %d", tNumber));
        out = new PrintWriter(String.format("../tests/%02d", tNumber++));
        out.println(n);
        for (int i = 0; i < n; ++i)
            out.print(a[i] + (i == n-1 ? "" : " "));
        out.println();
        out.close();
    }

    
    static void genSample() throws IOException {
        printTest(6, new int[]{5, 7, 10, 12, 8, 4});    
    }
    
    static int randFromTo(int l, int r) {
        return rnd.nextInt(r - l + 1) + l;      
    }

    static int pow(int x, int y) {
        int ans = 1;
        while (y --> 0) ans *= x;
        return ans;
    }

    public static void main(String[] args) throws IOException {
        new File("../tests").mkdir();        
        genSample();
        printTest(1, new int[]{100});
        for (int it = 0; it < 5; ++it) {
            int n = randFromTo(5, 20);
            int[] a = new int[n];
            for (int i = 0; i < n; ++i)
                a[i] = randFromTo(1, 100);
            printTest(n, a);
        }
        {
            int n = 100;
            int[] a = new int[n];
            for (int i = 0; i < n; ++i)
                a[i] = i+1;
            printTest(n, a);                            
        }
        for (int it = 0; it < 5; ++it) {
            int n = randFromTo(100, 1000);
            int[] a = new int[n];
            for (int i = 0; i < n; ++i)
                a[i] = randFromTo(10, 100000);
            printTest(n, a);
        }
        {
            printTest(2, new int[]{1, MAX_V});
        }
        for (int it = 0; it < 5; ++it) {
            int n = randFromTo(10000, 100000);
            int[] a = new int[n];
            for (int i = 0; i < n; ++i)
                a[i] = randFromTo(pow(2, i%15), pow(3, i%15));
            printTest(n, a);
        }
        for (int it = 0; it < 5; ++it) {
            int n = randFromTo(50000, 100000);
            int[] a = new int[n];
            for (int i = 0; i < n; ++i)
                a[i] = randFromTo(pow(2, i%15), pow(3, i%15));
            printTest(n, a);
        }
        {
            int n = 100000;
            int[] a = new int[n];
            for (int i = 0; i < n; ++i)
                a[i] = i%2 == 0 ? 1 : MAX_V;
            printTest(n, a);                            
        }
        {
            int n = 100000;
            int[] a = new int[n];
            for (int i = 0; i < n; ++i)
                a[i] = MAX_V;
            printTest(n, a);                            
        }                
    }                 
}




