import java.io.*;
import java.util.*;

public class TestGen {
    static final int MAX_D = 500;
    
    static PrintWriter out;
    static Random rnd = new Random(239017);
    static int tNumber = 1;
    
    static void printTest(int[] d, int[] r) throws IOException {
        System.out.println(String.format("Generating test %d", tNumber));
        out = new PrintWriter(String.format("../tests/%02d", tNumber++));
        for (int i = 0; i < 4; ++i)
            out.print(d[i] + (i == 3 ? "" : " "));
        out.println();
        for (int i = 0; i < 4; ++i)
            out.print(r[i] + (i == 3 ? "" : " "));
        out.println();
        out.close();
    }

    
    static void genSample() throws IOException {
        printTest(new int[]{7, 12, 5, 2},
                    new int[]{3, 8, 4, 0});    
    }
    
    static int randFromTo(int l, int r) {
        return rnd.nextInt(r - l + 1) + l;      
    }

    static int pow(int x, int y) {
        int ans = 1;
        while (y --> 0) ans *= x;
        return ans;
    }

    public static void main(String[] args) throws IOException {
        new File("../tests").mkdir();        
        genSample();
        for (int it = 0; it < 5; ++it) {
            int[] d = new int[4];
            int[] r = new int[4];
            for (int i = 0; i < 4; ++i) {
                d[i] = randFromTo(1, 10);
            }
            int x = randFromTo(10, 100);
            for (int i = 0; i < 4; ++i)
                r[i] = x % d[i];
            printTest(d, r);
        }

        for (int it = 0; it < 5; ++it) {
            int[] d = new int[4];
            int[] r = new int[4];
            for (int i = 0; i < 4; ++i) {
                d[i] = randFromTo(10, 250);
            }
            int x = randFromTo(10000, 1000000);
            for (int i = 0; i < 4; ++i)
                r[i] = x % d[i];
            printTest(d, r);
        }

        for (int it = 0; it < 5; ++it) {
            int[] d = new int[4];
            int[] r = new int[4];
            for (int i = 0; i < 4; ++i) {
                d[i] = randFromTo(400, 500);
            }
            int x = randFromTo(1000000, 1000000000);
            for (int i = 0; i < 4; ++i)
                r[i] = x % d[i];
            printTest(d, r);
        }
        
        for (int it = 0; it < 2; ++it) {
            int[] d = new int[4];
            int[] r = new int[4];
            for (int i = 0; i < 2; ++i) {
                d[i] = randFromTo(400, 499);
            }
            d[2] = d[0]+1;
            d[3] = d[1]+1;
            int x = randFromTo(100000000, 1000000000);
            for (int i = 0; i < 4; ++i)
                r[i] = x % d[i];
            printTest(d, r);
        }
        
        for (int it = 0; it < 2; ++it) {
            int[] d = new int[4];
            int[] r = new int[4];
            d[0] = randFromTo(400, 499);
            d[1] = d[0]+1;
            d[2] = d[1]+1;
            d[3] = d[2]+1;
            int x = randFromTo(100000000, 1000000000);
            for (int i = 0; i < 4; ++i)
                r[i] = x % d[i];
            printTest(d, r);
        }


    }                 
}




