import random
random.seed("basic04/periods")

class TestGen:
    def __init__(self):
        self.test_number = 0
    
    def generate_samples(self):
        self.print_test("abba")
        self.print_test("abadbab")
        self.print_test("daaa")

    def generate_min_tests(self):
        self.print_test("aa")
        self.print_test("zz")
        self.print_test("ba")
        self.print_test("aaa")
        self.print_test("abacaba")
                          
    def generate_hand_tests(self):
        pass

    def generate_random_test(self, maxn, maxc):
        s = ""
        for i in range(maxn):
            s += chr(random.randint(0, maxc) + ord('a'))
        self.print_test(s)

    def invert(self, s):
        t = ""
        for i in range(len(s)):
            if s[i] == 'a':
                t += 'b'
            else:
                t += 'a'
        return t

    def generate_tue_morse_string(self, maxn):
        s = "a"
        for i in range(10):
            s = s + self.invert(s)
        s = s[:maxn]
        self.print_test(s)

    def generate_tue_morse_string_period(self, maxn):
        s = "a"
        for i in range(9):
            s = s + self.invert(s)
        s = s + 'a' + s
        s = s[:maxn]
        self.print_test(s)

        s = "a"
        for i in range(9):
            s = s + self.invert(s)
        s = s + 'b' + s
        s = s[:maxn]
        self.print_test(s)

    def generate_tue_morse_string_with_extra_inside(self, maxn):
        s = "a"
        for i in range(10):
            s = s + self.invert(s)
        s = s[:maxn - 1]
        index = random.randint(0, len(s))
        s = s[:index] + chr(random.randint(0, 25) + ord('a')) + s[index:]
        self.print_test(s)

    def generate_period_string(self, maxn):
        maxn -= 1
        p = random.randint(1, maxn // 10)
        period = ""
        for i in range(p):
            period += chr(random.randint(0, 25) + ord('a'))
        cnt = maxn // p
        s = ""
        ind = random.randint(1, cnt - 1)
        for i in range(ind):
            s += period
        splitted = random.randint(0, len(period) - 1)
        left = period[:splitted + 1]
        right = period[splitted + 1:]
        s += left + chr(random.randint(0, 25) + ord('a')) + right
        while (len(s) + len(period) <= maxn):
            s += period
        s += period[:maxn - len(s)]
        self.print_test(s)

    def generate_max_tests(self, maxn):
        s = ""
        for i in range(maxn):
            s += 'a'
        self.print_test(s)

        s = ""
        for i in range(maxn):
            s += 'z'
        self.print_test(s)

        s = ""
        for i in range(maxn - 1):
            s += 'a'
        s += 'b'
        self.print_test(s)

        s = ""
        for i in range(maxn // 2):
            s += 'a'
        for i in range(maxn // 2):
            s += 'b'
        self.print_test(s)

        s = ""
        for i in range(maxn // 2):
            s += 'ab'
        self.print_test(s)

        s = ""
        for i in range((maxn // 2) - 1):
            s += chr(random.randint(0, 25) + ord('a'))
        s = s + 'a' + s
        self.print_test(s)

    def print_test(self, s):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "../tests/" + "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(s, file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        maxn = 10**6
        ns = [2, 3, 5, 10, 100, 1000, 10**5, maxn]
        nc = [1, 3, 5, 10, 20, 25]
        for n in ns:
            for c in nc:
                self.generate_random_test(n, c)
        for i in range(10):
            self.generate_period_string(maxn)
        self.generate_tue_morse_string(maxn)
        self.generate_tue_morse_string_period(maxn)
        self.generate_tue_morse_string_with_extra_inside(maxn)
        self.generate_max_tests(maxn)

    def generate_all_tests_argv(self, argv):
        pass            

if __name__ == "__main__":
    import os, shutil
    from sys import argv
    if os.path.exists('../tests'):
        print('Directory <<tests>> already exists')
        shutil.rmtree('../tests', ignore_errors=False, onerror=None)
    try:
        os.makedirs('../tests')
    except OSError:
        pass

    import time
    start = time.time()
    writer = TestGen()
    writer.generate_all_tests()
    #writer.generate_all_tests_argv(argv)
    finish = time.time()
    print('All tests were generated. Elapsed time: ', finish - start)